﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Hammurabi
{

    public partial class Form1 : Form
    {
        private int volk;
        private double getreide;
        private int land;
        private double landbes;          //land bestellen
        private int essenvolk;
        private double landkosten;          //kosten getreide pro hektar

        public Form1()
        {
            InitializeComponent();
            volk = 100;
            getreide = 2800;
            land = 1000;
            landbes = 0.5;
            essenvolk = 20;
            landkosten = 17;
            AktualisiereWerte();
        }

        private void AktualisiereWerte()
        {
            textBoxVolk.Text = volk.ToString();
            textBoxGetreide.Text = getreide.ToString();
            textBoxLand.Text = land.ToString();
        }

        private void buttonLandKaufen_Click(object sender, EventArgs e)
        {
            //TODO: Eingabefehler abfangen, z.B. mit int.TryParse
            int landkauf = Convert.ToInt32(textBoxLandKaufen.Text);
            double kosten = landkauf * landkosten;
            if (checkBoxKaufen.Checked) //dafür gibt es RadioButtons
            {                
                if (kosten > getreide)
                {
                    textBoxLog.Text = "zu wenig getreide";
                }
                else
                {
                    getreide -= kosten;
                    land += landkauf;
                    textBoxLog.Text = "Land gekauft";
                }
            }
            else
            {
                getreide += kosten;
                land -= landkauf;
            }
            AktualisiereWerte();
        }

        private void buttonNaechstesJahr_Click(object sender, EventArgs e)
        {
            Random r = new Random();
            landkosten = r.Next(17, 27);

            int futter = int.Parse(textBoxFutter.Text);
            if (volk * essenvolk > futter)
            {
                volk = futter / essenvolk;
            }
            getreide -= volk * essenvolk;

            int anbau = int.Parse(textBoxLandAnbau.Text);
            if (anbau > volk * 10) anbau = volk * 10;
            double ertrag = 1 + 3 * r.NextDouble();
            getreide += anbau * (ertrag - landbes);

            double c = 5 * r.NextDouble();
            int zuzug = (int)(c * (20 * land + getreide) / volk / 100 + 1);
            getreide *= 0.99 + 0.01 * r.NextDouble(); //Ratten
            if (r.Next(0, 100) < 15) volk /= 2; //Seuche
            volk += zuzug;

            AktualisiereWerte();
        }
    }
}
